/*************************************************************************
 *
 *
 *    (c) Copyright Olimex 2010
 *
 *    File name   : extcon_test.h
 *    Description : External connectors test
 *
 *    History :
 *    1. Date        : 25, January 2010
 *       Author      : Aleksandar Mitev
 *       Description : Create
 *
 **************************************************************************/

#ifndef _EXT_CON_TEST
#define _EXT_CON_TEST

// definition of the used ports array
typedef enum _PORTS_USED {
	GPIOA, GPIOB, GPIOC
} PORTS_USED;	

// definition of ports names
#define PORTS_NAMES(name) const ROM char* name[] = \
	   { "PORTA", "PORTB", "PORTC" }

typedef enum _EXT_CONS_USED {
	UEXT, PCB_CON
} EXT_CONS_USED;

// definition of external connectors names
#define EXT_CON_NAMES(name) const ROM char* name[] = \
	{ "UEXT", "PCB_HEADER", }

// structure defining a pin
typedef struct _PIN {
	PORTS_USED GPIO_Port;
	BYTE GPIO_Pin;
	EXT_CONS_USED EXT_Con;
	BYTE EXT_Pin;
} PIN;

// structure defining a connector
typedef const struct _EXT_CON_DESC {
	const ROM PIN *pullPin;
	const ROM PIN *pins;
	BYTE numOfPins;
} EXT_CON_DESC;

// the function for testing a connector
int ExtConTest(ROM EXT_CON_DESC *conn, int startFlag);

// check for connected JTAG connector
int ExtConConnected(ROM EXT_CON_DESC *conn);

// pin manipulation functions
BYTE ReadPin(const ROM PIN *pPin);
void ClearPin(const ROM PIN *pPin);
void SetPin(const ROM PIN *pPin);
void MakePinOutput(const ROM PIN* pPin);
void MakePinInput(const ROM PIN* pPin);

// declarations of the connecter descriptors
extern ROM EXT_CON_DESC UEXT_desc;
extern ROM EXT_CON_DESC PCB_CON_desc;

#endif // _EXT_CON_TEST



